scala.runtime

# ScalaRunTime

#### object ScalaRunTime

The object ScalaRunTime provides support methods required by the scala runtime. All these methods should be considered outside the API and subject to change or removal without notice.

Source
  ScalaRunTime.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ScalaRunTime
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### def _equals(x: Product, y: Any): Boolean

7. #### def _hashCode(x: Product): Int

8. #### def _toString(x: Product): String

9. #### def anyValClass[T <: AnyVal](value: T)(implicit arg0: ClassTag[T]): Class[T]

   Return the class object representing an unboxed value type, e.

   Return the class object representing an unboxed value type, e.g. classOf[int], not classOf[java.lang.Integer]. The compiler rewrites expressions like 5.getClass to come here.

10. #### def arrayClass(clazz: Class[_]): Class[_]

    Return the class object representing an array with element class `clazz`.

11. #### def arrayElementClass(schematic: Any): Class[_]

    Return the class object representing elements in arrays described by a given schematic.

12. #### def array_apply(xs: AnyRef, idx: Int): Any

    Retrieve generic array element

13. #### def array_clone(xs: AnyRef): AnyRef

14. #### def array_length(xs: AnyRef): Int

    Get generic array length

15. #### def array_update(xs: AnyRef, idx: Int, value: Any): Unit

    update generic array element

16. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

17. #### def checkInitialized[T <: AnyRef](x: T): T

18. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

19. #### def ensureAccessible(m: Method): Method

20. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

22. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

23. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def hash(x: Unit): Int

25. #### def hash(x: Boolean): Int

26. #### def hash(x: Char): Int

27. #### def hash(x: Byte): Int

28. #### def hash(x: Short): Int

29. #### def hash(x: Int): Int

30. #### def hash(x: Number): Int

31. #### def hash(lv: Long): Int

32. #### def hash(fv: Float): Int

33. #### def hash(dv: Double): Int

34. #### def hash(x: Any): Int

35. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

36. #### def inlinedEquals(x: AnyRef, y: AnyRef): Boolean

    Fast path equality method for inlining; used when -optimise is set.

    Fast path equality method for inlining; used when -optimise is set.

    Annotations
      @inline ()

37. #### def isAnyVal(x: Any): Boolean

38. #### def isArray(x: Any, atLevel: Int): Boolean

39. #### def isArray(x: AnyRef): Boolean

40. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

41. #### def isTuple(x: Any): Boolean

42. #### def isValueClass(clazz: Class[_]): Boolean

43. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

46. #### def replStringOf(arg: Any, maxElements: Int): String

    stringOf formatted for use in a repl result.

47. #### def sameElements(xs1: collection.Seq[Any], xs2: collection.Seq[Any]): Boolean

    A helper method for constructing case class equality methods, because existential types get in the way of a clean outcome and it's performing a series of Any/Any equals comparisons anyway.

    A helper method for constructing case class equality methods, because existential types get in the way of a clean outcome and it's performing a series of Any/Any equals comparisons anyway. See ticket #2867 for specifics.

48. #### def stringOf(arg: Any, maxElements: Int): String

49. #### def stringOf(arg: Any): String

    Given any Scala value, convert it to a String.

    Given any Scala value, convert it to a String.

    The primary motivation for this method is to provide a means for correctly obtaining a String representation of a value, while avoiding the pitfalls of naïvely calling toString on said value. In particular, it addresses the fact that (a) toString cannot be called on null and (b) depending on the apparent type of an array, toString may or may not print it in a human-readable form.

    arg

      the value to stringify

    returns

      a string representation of arg.

50. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

51. #### def toArray[T](xs: collection.Seq[T]): Array[AnyRef]

52. #### def toObjectArray(src: AnyRef): Array[AnyRef]

    Convert an array to an object array.

    Convert an array to an object array. Needed to deal with vararg arguments of primitive types that are passed to a generic Java vararg parameter T ...

53. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

54. #### def typedProductIterator[T](x: Product): Iterator[T]

    A helper for case classes.

55. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

56. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

57. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

### Inherited from AnyRef

### Inherited from Any

### Ungrouped